<?php
/**
 * @link      http://github.com/zendframework/ZendSkeletonApplication for the canonical source repository
 * @copyright Copyright (c) 2005-2016 Zend Technologies USA Inc. (http://www.zend.com)
 * @license   http://framework.zend.com/license/new-bsd New BSD License
 */

namespace Application\Controller;

use Zend\Mvc\Controller\AbstractActionController;
use Zend\View\Model\ViewModel;
use Khansia\Generic\Result;

class AdminController extends \Application\Master\GlobalActionController 
{
    public function __construct($headScript)
    {
        $this->headScript = $headScript;
    }

    public function indexAction()
    {
        echo 'forbidden';die;
    }
    public function dasboardAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();
        
      
       $uri     = $this->getRequest()->getUri();
       $baseurl = sprintf('//%s', $uri->getHost());

       $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
       $this->headScript->appendFile('/action-js/antrian-js/action-panggil.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function antrianadminAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();
        
        /* get url */
        $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

        $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
        $this->headScript->appendFile('/action-js/antrian-js/action-admin.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function registrasidokterAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();
        
        /* get url */
        $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

        $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
        $this->headScript->appendFile('/action-js/antrian-js/action-registrasidokter.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function kelolapasienAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();
        
        /* get url */
        $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

        $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
        $this->headScript->appendFile('/action-js/antrian-js/action-kelolapasien.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function kelolapoliAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();
        
        /* get url */
        $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

        $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
        $this->headScript->appendFile('/action-js/antrian-js/action-kelolapoli.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function keloladokterAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();
        
        /* get url */
        $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

        $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
        $this->headScript->appendFile('/action-js/antrian-js/action-keloladokter.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function kelolaruanganAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();
        
        /* get url */
        $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

        $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
        $this->headScript->appendFile('/action-js/antrian-js/action-kelolaruang.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function tableAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
       // $result = new Result();
        
        /* get url */
       // $uri     = $this->getRequest()->getUri();
       // $baseurl = sprintf('//%s', $uri->getHost());

        //$this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
        //$this->headScript->appendFile('/action-js/index-js/action-listdata.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function cobainAction()
    {
		//$this->isLoggedIn();
       // $view   = new ViewModel();
        $result = new Result();
        
        /* get url */
       $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

    //    $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
    //    $this->headScript->appendFile('/action-js/index-js/action-listdata.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
    public function tampilanumumAction()
    {
		$this->isLoggedIn();
        $view   = new ViewModel();
        $result = new Result();

        // require_once(APPPATH.'vendor/autoload.php');
        // $options = array(
        //     'cluster' => 'ap1',
        //     'useTLS' => true
        // );
        // $pusher = new PusherPusher(
        //     '6f23df2468d8c1c7d0a2', //ganti dengan App_key pusher Anda
        //     'd2c2bf5a98edcdddfda2', //ganti dengan App_secret pusher Anda
        //     '1090832', //ganti dengan App_key pusher Anda
        //     $options
        // );
 
        // $data['message'] = 'success';
        // $pusher->trigger('my-channel', 'my-event', $data);

        

        $today      = gmdate("d M Y ", time()+60*60*7);
        $view->setVariable('today', $today);
        
        /* get url */
       $uri     = $this->getRequest()->getUri();
        $baseurl = sprintf('//%s', $uri->getHost());

       $this->headScript->appendScript(' var baseURL = "' . $baseurl . '"');        
       $this->headScript->appendFile('/action-js/antrian-js/action-umum.js');

        $this->layout("layout/layoutAdmin");
        return $view;
    }
}
